#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "gpio_common.h"

#define FILE_LENGTH 512

int gpio_init(int gpio,DIRECTION direction,EDGE edge)
{
	char cmd[1024] = {0};
	char file[64] = {0};
	FILE * fd_tmp;
	
    memset(file,0,sizeof(file));
    sprintf(file, "/sys/class/gpio/gpio%d", gpio);
    if( access(file, F_OK) < 0)
    {
        memset(cmd,0,sizeof(cmd));
        sprintf(cmd, "echo %d > /sys/class/gpio/export", gpio);
        system(cmd);
    }

	if ( direction == INPUT )
	{
		memset(file,0,sizeof(file));
		sprintf(file,"/sys/class/gpio/gpio%d/direction",gpio);
		fd_tmp = fopen(file,"w");
		if (fd_tmp == NULL)
		{
			printf("open %s fail\n",file);
			return -1;
		}
		fprintf(fd_tmp,"in");
//        printf("set direction int success.\n");
		fclose(fd_tmp);
	}
	else if ( direction == OUTPUT )
	{
		memset(file,0,sizeof(file));
		sprintf(file,"/sys/class/gpio/gpio%d/direction",gpio);
		fd_tmp = fopen(file,"w");
		if (fd_tmp == NULL)
		{
			printf("open %s fail\n",file);
			return -1;
		}
		fprintf(fd_tmp,"out");
//        printf("set direction out success.\n");
		fclose(fd_tmp);
	}
	if ( edge == NONE )
	{
		memset(file,0,sizeof(file));
		sprintf(file,"/sys/class/gpio/gpio%d/edge",gpio);
		fd_tmp = fopen(file,"w");
		if (fd_tmp == NULL)
		{
			printf("open %s fail\n",file);
			return -1;
		}
	
		fprintf(fd_tmp,"none");
		fclose(fd_tmp);

	}
	else if ( edge == RISING )
	{
		memset(file,0,sizeof(file));
		sprintf(file,"/sys/class/gpio/gpio%d/edge",gpio);
		fd_tmp = fopen(file,"w");
		if (fd_tmp == NULL)
		{
			printf("open %s fail\n",file);
			return -1;
		}
	
		fprintf(fd_tmp,"rising");
		fclose(fd_tmp);
	}
	else if ( edge == FALLING )
	{
		memset(file,0,sizeof(file));
		sprintf(file,"/sys/class/gpio/gpio%d/edge",gpio);
		fd_tmp = fopen(file,"w");
		if (fd_tmp == NULL)
		{
			printf("open %s fail\n",file);
			return -1;
		}
	
		fprintf(fd_tmp,"falling");
		fclose(fd_tmp);
	}
	else if ( edge == BOTH )
	{
		memset(file,0,sizeof(file));
		sprintf(file,"/sys/class/gpio/gpio%d/edge",gpio);
		fd_tmp = fopen(file,"w");
		if (fd_tmp == NULL)
		{
			printf("open %s fail\n",file);
			return -1;
		}
	
		fprintf(fd_tmp,"both");
		fclose(fd_tmp);
	}
	return 0;
}

int set_value(int gpio_pin, char* value)
{
    FILE* fd;
    char file_name[FILE_LENGTH];
    char buffer[32];
    int ret;

    sprintf(file_name,"/sys/class/gpio/gpio%d/value",gpio_pin);

    fd = fopen(file_name,"w");
    if (fd == NULL)
    {
        printf("open %s fail, line:%d\n",file_name, __LINE__);
        fclose(fd);
        return 0;
    }

    ret = fprintf(fd,value);

    fclose(fd);
    if(ret < 0 ){
        printf("write value failed.\n");
        return 0;
    }

    return 1;
}

int set_value(int gpio_pin, int value)
{
    FILE* fd;
    char file_name[FILE_LENGTH];
    char buffer[32];
    char cmd[512];
    int ret;

//    sprintf(file_name,"/sys/class/gpio/gpio%d/value",gpio_pin);

//    fd = fopen(file_name,"w");
//    if (fd == NULL)
//    {
//        printf("open %s fail, line:%d\n",file_name, __LINE__);
//        fclose(fd);
//        return 0;
//    }

//    ret = fprintf(fd,value);
    memset(cmd,0,sizeof(cmd));
    sprintf(cmd,"echo %d > /sys/class/gpio/gpio%d/value",value, gpio_pin);
    system(cmd);

//    fclose(fd);
//    if(ret < 0 ){
//        printf("write value failed.\n");
//        return 0;
//    }

    return 1;
}

int read_value(int pin)
{
    FILE* fd;
    char file_name[FILE_LENGTH];
    char buffer[32];
    int len;

    memset(file_name, 0, FILE_LENGTH);
    sprintf(file_name, "/sys/class/gpio/gpio%d/value", pin);

    fd = fopen(file_name, "r");
    if (fd == NULL)
    {
        printf("open %s fail, line:%d\n",file_name, __LINE__);
        fclose(fd);
        return -1;
    }
    //printf("open %s ok, line:%d\n",file_name, __LINE__);

    if((len=fread(buffer, 1, sizeof(buffer), fd)) < 0)
    {
        printf("read failed!, return %d\n", len);
        fclose(fd);
        return -1;
    }
    buffer[len]='\0';

    fclose(fd);

//    printf("%s debug ---> %s\n", __FUNCTION__, buffer);
    return atoi(buffer);
}

int set_voltage(FILE * fd,int value)
{
	if (fd != NULL)
	{
		if (value == 0 )
		{	
			fprintf(fd,"0");	
		}
		else
		{
			fprintf(fd,"1");
		}
		rewind(fd);
		return 0;
	}
	else
	{
		return -1;
	}
}

int get_voltage(int fd)
{
	char buffer[16];
	int len;
	
	if((len=read(fd,buffer,sizeof(buffer)))==-1)
	{
		perror("read failed!\n");
		return -1;
	}
	buffer[len]=0;
	return atoi(buffer);
}

void gpio_release(int gpio)
{
	char cmd[1024];
	memset(cmd,0,sizeof(cmd));
	sprintf(cmd,"echo %d > /sys/class/gpio/unexport",gpio);
	system(cmd);
}
