#include <getopt.h>
#include <stdlib.h>
#include "gpio_common.h"
#include "gpio_case.h"
#include <stdio.h>
#include <unistd.h>
#include <iostream>

#include <stdint.h>
#include <string>

#include "dht12.h"
#include "eaidk310_sensor_cases.h"

using namespace std;

enum SCENE_TYPE {
	CASE_LED = 0,
	CASE_RELAY,
	CASE_INFRARED,
	CASE_DIGTRON,
	CASE_MAX,
};

struct goip_case {
	int case_;
	int (*case_fun)();
};

/*
const struct goip_case goip_case_arr[CASE_MAX] = {
								{CASE_LED,&led_demo},
								{CASE_RELAY,&relay_demo},
								{CASE_INFRARED,&infrared_demo},
								{CASE_DIGTRON,&digtron_demo},
							};

*/
static void usage(char **argv)
{
	printf(
		"Usage: %s [Options]\n\n"
		"Options:\n"
        "-s devicename, device name list includes flame/relay/pushbotton/shock/minireed/reed/buzzer/passivebuzzer/twocolor/littletwocolor/sevencolor/laseremit/threecolor/threecolorsmd/"
        "tiltswitch/touch/photoresistor/ballswitch/lightcup/iremit/sound/tap/lightblock"
		"\n",
		argv[0]);
}

int main(int argc, char **argv)
{

    int opt;
    std::string eaidk310_case;

    while((opt = getopt(argc, argv, "s:")) != -1)
	{
        switch (opt)
		{
            case 's':
//                printf("opt is %c\n", opt);
                eaidk310_case = optarg;

                printf("optarg is %s, eaidk310_case: %s \n", optarg, eaidk310_case.c_str());
                break;
			default:
				usage(argv);
				return 0;
		}
    }

    printf("test the device begins in 3 seconds.\n");
    sleep(1);

    //phase 1
    if(eaidk310_case.compare("flame") == 0){
        eaidk310_sensor_flame(79, 82);
    }else if(eaidk310_case.compare("relay") == 0){
        eaidk310_sensor_relay(79);
    }else if(eaidk310_case.compare("pushbotton") == 0){
        eaidk310_sensor_pushbotton(79);
    }else if(eaidk310_case.compare("shock") == 0){
        eaidk310_sensor_shock(79);
    }else if(eaidk310_case.compare("minireed") == 0){
        eaidk310_sensor_minireed(79);
    }else if(eaidk310_case.compare("reed") == 0){
        eaidk310_sensor_reed(79, 82);
    }else if(eaidk310_case.compare("buzzer") == 0){
        eaidk310_sensor_buzzer(79);
    }else if (eaidk310_case.compare("passivebuzzer") == 0){
        eaidk310_sensor_passive_buzzer(79);
    }else if(eaidk310_case.compare("twocolor") == 0){
        eaidk310_sensor_twocolor_led(79, 82);
    }else if(eaidk310_case.compare("littletwocolor") == 0){
        eaidk310_sensor_little_twocolor_led(79, 82);
    }else if(eaidk310_case.compare("sevencolor") == 0){
        eaidk310_sensor_7color_flash(79);
    }else if(eaidk310_case.compare("laseremit") == 0){
        eaidk310_sensor_laser_emit(79);
    }else if(eaidk310_case.compare("threecolor") == 0){
        eaidk310_sensor_threecolor_led(79,82,81);
    }else if(eaidk310_case.compare("threecolorsmd") == 0){
        eaidk310_sensor_threecolor_smd(79,82,81);

    // phase 2
    }else if(eaidk310_case.compare("tiltswitch") == 0){
        eaidk310_sensor_tilt_switch(79);
    }else if(eaidk310_case.compare("hall") == 0){
        eaidk310_sensor_hall_magnatic(79);
    }else if(eaidk310_case.compare("analoghall") == 0){
        eaidk310_sensor_hall_magnatic(79);
    }else if(eaidk310_case.compare("linearhall") == 0){
        eaidk310_sensor_linear_hall(79,82);
    }else if(eaidk310_case.compare("touch") == 0){
        eaidk310_sensor_touch(79,82);
    }else if(eaidk310_case.compare("photoresistor") == 0){
        eaidk310_sensor_photoresistor(79);
    }else if(eaidk310_case.compare("ballswitch") == 0){
        eaidk310_sensor_ball_switch(79);
    }else if(eaidk310_case.compare("lightcup") == 0){
        eaidk310_sensor_light_cup(79,82);
    }else if(eaidk310_case.compare("iremit") == 0){
        eaidk310_sensor_IRemission(79);
    }else if(eaidk310_case.compare("sound") == 0){
        eaidk310_sensor_microphone(79, 82);
    }else if(eaidk310_case.compare("tap") == 0){
        eaidk310_sensor_tap_module(79);
    }else if(eaidk310_case.compare("lightblock") == 0){
        eaidk310_sensor_light_block(79);

    //phase 3
    }else if(eaidk310_case.compare("track") == 0){
        eaidk310_sensor_tracking(79);
    }else if(eaidk310_case.compare("avoid") == 0){
        eaidk310_sensor_avoid(79);
    }else if(eaidk310_case.compare("rotary") == 0){
        eaidk310_sensor_rotary_encode(79, 82, 81);
    }
    else{
//        char* s1="abc";
//        char* s2="ABC";
//        cout<<"s1 is "<<*s1<<endl;
//        cout<<"s2 is "<<*s2<<endl;
//        pcf8591_arduino_demo();
        printf("there is no options. \n");
        usage(argv);
    }

	return 0;
}

