#include<fcntl.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<math.h>

#include "iic_common.h"

int i2c_open(char* dev)
{
	int fd = open(dev, O_RDWR);
	if(fd < 0){
		perror("Unable to open i2c controlfile");
		return -1;
	}
	return fd;
}

int i2c_write_bytes(int fd, unsigned char addr,unsigned char* data, unsigned short len)
{    
    unsigned char* write_data = (unsigned char*)malloc(len + 1);
	if(write_data == NULL)
    {
        return -1;
    }

    write_data[0] = addr;
    memcpy(&write_data[1], data, len);
    
    
    if (write(fd, write_data, len + 1) != len+1)
    {
    	free(write_data);
		return -1;
	}

    free(write_data);
	return 0;
}


int i2c_read_bytes(int fd, unsigned char addr, unsigned char* buf, unsigned short len)
{
	char writeBuff[1] = {addr};
	if(write(fd, writeBuff, 1)!=1)
	{
        printf("Failed to reset the write address\n");
		return 1;
	}
    if (read(fd, buf, len)<0)
	{
		printf("Read data fail\n");
		return -1;
	}
	return 0;
    //printf("buf[0] = 0x%x\n", buf[0]);
    
    //printf("Read data success\n");
}

int myAnalogRead (int fd)
{
//  int  chan = pin - node->pinBase ;
//  int  fd = node->fd ;
  char buffer [4096] ;
  char *p ;
  int  temp, sign ;

//  if (chan != 0)
//    return -9999 ;

// Rewind the file - we're keeping it open to keep things going
//	smoothly

  lseek (fd, 0, SEEK_SET) ;

// Read the file - we know it's only a couple of lines, so this ought to be
//	more than enough

  if (read (fd, buffer, 4096) <= 0)	// Read nothing, or it failed in some odd way
  {
      printf("111111111111\n");
    return -9998 ;
  }
// Look for YES, then t=

  if (strstr (buffer, "YES") == NULL)
  {
      printf("222222222222\n");
    return -9997 ;
  }

  if ((p = strstr (buffer, "t=")) == NULL)
  {
      printf("33333333333\n");
    return -9996 ;
  }

// p points to the 't', so we skip over it...
  p += 2 ;

// and extract the number
//	(without caring about overflow)

  if (*p == '-')	// Negative number?
  {
    sign = -1 ;
    ++p ;
  }
  else
    sign = 1 ;

  temp = 0 ;
  while (isdigit (*p))
  {
    temp = temp * 10 + (*p - '0') ;
    ++p ;
  }

// We know it returns temp * 1000, but we only really want temp * 10, so
//	do a bit of rounding...

  temp = (temp + 50) / 100 ;
  printf("temp is %d\n", temp*sign);
  return temp * sign ;
}
